#include <algorithm>
#include <iostream>
#include <string>
#include <unordered_map>
#include <vector>

class Song {
  public:
	Song() = default;
	Song(std::string artist, std::string title, float rating = 0.f)
	  : artist_(std::move(artist)), title_(std::move(title)), rating_(rating) {
	}
	
	const std::string& artist()const {return artist_;}
	const std::string& title()const {return title_;}
	float rating()const {return rating_;}
	void  rating(float rating) {rating_ = rating;}
 
  private:
    std::string artist_;
    std::string title_;
    float       rating_ = 0.f;
};

// TODO

int main() {
	auto library = Music_library{};
	library.insert(Song{"Blind Guardian", "The Bard's Song", 10.f});
	library.insert(Song{"Blind Guardian", "Valhalla",         9.2f});
	library.insert(Song{"Blind Guardian", "Sacred Worlds",    9.8f});
	library.insert(Song{"Blind Guardian", "Silence"});

	if(auto song = library.find_by_title("The Bard's Song")) {
		std::cout << "Song gefunden: " << song->artist() << " - " << song->title() << "\n";
	} else {
		std::cout << "Fehler: 'The Bard's Song' sollte enthalten sein!\n";
	}

	if(auto artist = library.find_by_artist("Blind Guardian")) {
		std::cout << "Artist gefunden: \n";
		for(auto& song : *artist) {
			std::cout << "\t" << song->title() << "\n";
		}
	} else {
		std::cout << "Fehler: Blind Guardian sollte enthalten sein!\n";
	}
}

